﻿Public Class dlgDbGenerator

    Public _SelectedProvider As String
    Private _providerData As ProviderData = Nothing

    Public Sub New(providerData As ProviderData)
        InitializeComponent()
        _providerData = providerData
    End Sub

    Private Sub frm_Load(sender As Object, e As EventArgs) Handles Me.Load
        tbServerOrFile.Text = _providerData.ServerOrFile
        tbDbName.Text = _providerData.DbName
        tbUsername.Text = _providerData.Username
        tbPass.Text = _providerData.Pass
    End Sub

    Private Sub rbtn_CheckedChanged(sender As Object, e As EventArgs) Handles rbtnAccess.CheckedChanged,
                                                                              rbtnMySQL.CheckedChanged,
                                                                              rbtnMsSQL.CheckedChanged,
                                                                              rbtnCmdOnly.CheckedChanged,
                                                                              rbtnRun.CheckedChanged
        Select Case True
            Case sender Is rbtnAccess
                _SelectedProvider = "Access"
                If rbtnRun.Checked Then ctlAccess()
            Case sender Is rbtnMySQL
                _SelectedProvider = "MySQL"
                If rbtnRun.Checked Then ctlSql()
            Case sender Is rbtnMsSQL
                _SelectedProvider = "MsSQL"
                If rbtnRun.Checked Then ctlSql()
            Case sender Is rbtnCmdOnly : pnl.Enabled = False
            Case sender Is rbtnRun
                pnl.Enabled = True
                If rbtnAccess.Checked Then
                    ctlAccess()
                ElseIf rbtnMsSQL.Checked OrElse rbtnMySQL.Checked Then
                    ctlSql()
                End If
        End Select
    End Sub

    Private Sub ctlAccess()
        tbServerOrFile.Enabled = True
        tbDbName.Enabled = False
        tbUsername.Enabled = False
        tbPass.Enabled = True
    End Sub

    Private Sub ctlSql()
        tbServerOrFile.Enabled = True
        tbDbName.Enabled = True
        tbUsername.Enabled = True
        tbPass.Enabled = True
    End Sub

End Class