﻿Public Class frmDgvTemplate

    Private _appMod As String = "app_"

#Region "Form"

    Private Sub frm_Load(sender As Object, e As EventArgs) Handles Me.Load
        Me.KeyPreview = True
        accessSettings()
        dgv_Settings()
    End Sub

    Private Sub frm_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        If ShowClosingDialog() Then e.Cancel = True
    End Sub

    Private Sub frm_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown
        Select Case e.KeyCode
            Case Keys.Escape : Close()
        End Select
    End Sub

#End Region 'Form

#Region "Clickables"

    Private Sub ts_Click(sender As Object, e As EventArgs) Handles tsEdit.Click,
                                                                   tsNew.Click,
                                                                   tsMultiEdit.Click,
                                                                   tsFastEdit.Click
        Select Case True
            Case sender Is tsNew : createNew()
            Case sender Is tsEdit : Edit()
            Case sender Is tsMultiEdit : MultiEdit()
            Case sender Is tsFastEdit : FastEdit()
        End Select
    End Sub

    Private Sub cms_Click(sender As Object, e As EventArgs) Handles cmsNew.Click,
                                                                    cmsEdit.Click,
                                                                    cmsMultiEdit.Click,
                                                                    cmsFastEdit.Click,
                                                                    cmsColSelect.Click,
                                                                    cmsColAutoSize.Click,
                                                                    cmsCopy.Click,
                                                                    cmsExportXL.Click,
                                                                    cmsImportXL.Click,
                                                                    cmsInfo.Click
        Select Case True
            Case sender Is cmsNew : createNew()
            Case sender Is cmsEdit : Edit()
            Case sender Is cmsMultiEdit : MultiEdit()
            Case sender Is cmsFastEdit : FastEdit()
            Case sender Is cmsColSelect : dgv.GetSetDgvColumnSettings(True, Me)
            Case sender Is cmsColAutoSize : SetDgvColumnWidthAutosizeOnce(dgv)
            Case sender Is cmsCopy : dgv.copyExportSelection(False)
            Case sender Is cmsExportXL : dgv.copyExportSelection(True)
            Case sender Is cmsImportXL
            Case sender Is cmsInfo : dgv.infoDGV
        End Select
    End Sub

#End Region 'Clickables

#Region "BS"

    Private Sub createNew()
        bs.ShowCreateNewDialog(Of ...)
    End Sub

    Private Sub Edit()
        If hasEditEntryAccess(_appMod) Then bs.ShowEditDialog(Of ...) Then
    End Sub

    Private Sub MultiEdit()
        dgv.ShowMultiEditDialog(Of ...)
    End Sub

    Private Sub FastEdit()
        dgv.DGVFastEdit(tsFastEdit, cmsFastEdit)
    End Sub

    Private Sub bsView()

    End Sub

#End Region 'BS

#Region "DGV"

    Private Sub dgv_Settings()
        dgv.registerDgvSettings
        dgv.freezeCol(blablub)
        dgv.GetSetDgvColumnSettings(False, Me)
    End Sub

    Private Sub dgv_SelectionChanged(sender As Object, e As EventArgs) Handles dgv.SelectionChanged
        dgv.selectedRowsCount(tssMarkiert)
    End Sub

    Private Sub dgv_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgv.CellDoubleClick
        If Not e.RowIndex < 0 Then Edit()
    End Sub

    Private Sub dgv_KeyDown(sender As Object, e As KeyEventArgs) Handles dgv.KeyDown
        Select Case e.KeyCode
            Case Keys.Delete
                If hasDeleteAccess(_appMod) Then
                    If Dts.HasChanges Then Dts.SaveDts()
                    dgv.AllowUserToDeleteRows = True
                    e.Handled = msgQuestionWarning("Die markierten Zeilen werden endgültig gelöscht, fortfahren?") = DialogResult.No
                Else
                    msgDeleteDenied()
                    e.Handled = True
                End If
        End Select
    End Sub

#End Region 'DGV

#Region "Zugriffssteuerung"

    Private Sub accessSettings()
        If Not hasNewEntryAccess(_appMod) Then hideTS(tsNew, cmsNew)
        If Not hasEditEntryAccess(_appMod) Then hideTS(tsEdit, cmsEdit)
        If Not hasMultiEditAccess(_appMod) Then hideTS(tsMultiEdit, cmsMultiEdit)
        If Not hasFastEditAccess(_appMod) Then hideTS(tsFastEdit, cmsFastEdit)
        If Not _UA_IsAdmin Then hideTS(cmsImportXL)
    End Sub

#End Region 'Zugriffssteuerung

End Class