﻿Imports System.Runtime.CompilerServices
Imports System.Windows.Forms, System.Collections, System.Drawing

Public Module frmHandling

#Region "Suchfelder"

    ''' <summary>Sorgt dafür, dass von einem Suchfeld aus die Suchparameter/Schlüssel in Form von RadioButtons per Tastendruck verändert werden können </summary>
    <Extension>
    Public Sub frmSuche(form As Form, suchfeld As TextBox, groupbox As GroupBox)
        If form.ActiveControl Is suchfeld Then
            Dim aCtl As RadioButton = Nothing
            For Each ctl As Control In groupbox.Controls
                Dim rbtn = TryCast(ctl, RadioButton)
                If rbtn IsNot Nothing Then
                    If rbtn.Checked Then aCtl = rbtn
                End If
            Next
            groupbox.SelectNextControl(aCtl, True, False, False, True)
            suchfeld.Select() : suchfeld.SelectAll()
        Else
            suchfeld.Select() : suchfeld.SelectAll()
        End If
    End Sub

    <Extension>
    Public Sub frmSuche(form As Form, suchfeld As TextBox)
        If Not form.ActiveControl Is suchfeld Then
            suchfeld.Select() : suchfeld.SelectAll()
        End If
    End Sub

#End Region 'Suchfelder

#Region "Dialog" 'wegen lokalen Abhängigkeiten in's Hauptprojekt verschoben

#If True Then

    ''' <summary> übernimmt das Key-Handling eines Dialogs </summary>
    <Extension>
    Public Sub RegisterDlgKeyHandling(dlg As Form)
        'KeyDown
        AddHandler dlg.KeyDown, AddressOf dlg_KeyDown
        'TextBox-Behaviour
        Dim getChilds As Func(Of Control, IEnumerable) = Function(ctl) ctl.Controls '.Controls
        For Each ctl In getChilds.All(dlg)
            Dim tb = TryCast(ctl, TextBox)
            If tb.NotNull Then
                RegisterTextBoxSelectAll(tb)
            End If
        Next
    End Sub

    Private Sub dlg_KeyDown(sender As Object, e As KeyEventArgs)
        Dim dlg = DirectCast(sender, Form)
        Dim ctlCmb = TryCast(dlg.ActiveControl, ComboBox)
        Dim ctlRtxt = TryCast(dlg.ActiveControl, RichTextBox)
        Select Case e.KeyCode
            Case Keys.Escape : dlg.DialogResult = DialogResult.Cancel
            Case Keys.Enter : sendTab()
            Case Keys.F6 : dlg.DialogResult = DialogResult.OK
            Case Keys.Down
                If ctlCmb Is Nothing AndAlso ctlRtxt Is Nothing Then sendTab()
            Case Keys.Up
                If ctlCmb Is Nothing AndAlso ctlRtxt Is Nothing Then backTab()
        End Select
    End Sub

#End If

#End Region 'Dialog

#Region "Cursor"

    ''' <summary> Versetzt den Cursor in den Zustand "Wait" </summary>
    Public Sub WaitCursor()
        Cursor.Current = Cursors.WaitCursor
    End Sub

    ''' <summary> Versetzt den Cursor in den Zustand "Default" </summary>
    Public Sub DefaultCursor()
        Cursor.Current = Cursors.Default
    End Sub

#End Region 'Cursor

#Region "Controls"

    ''' <summary> deaktiviert Controls </summary>
    Public Sub deactivateControl(ParamArray controls As Control())
        For Each ctl In controls
            ctl.Enabled = False
        Next
    End Sub

#End Region 'Controls

End Module
