﻿Public Class frmAnrede

#Region "Form"

    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub frm_Load(sender As Object, e As EventArgs) Handles Me.Load
        dgv.RegisterDgvSettings
    End Sub

#End Region 'Form

#Region "Clickables"

    Private Sub tsDatei_Click(sender As Object, e As EventArgs) Handles tsSave.Click,
                                                                        tsPrint.Click,
                                                                        tsPageSetup.Click,
                                                                        tsClose.Click
        Select Case True
            Case sender Is tsSave : Dts.SaveDts()
            Case sender Is tsPrint
            Case sender Is tsPageSetup
            Case sender Is tsClose : Me.Close()
        End Select
    End Sub

    Private Sub cms_Click(sender As Object, e As EventArgs) Handles cmsNew.Click,
                                                                    cmsEdit.Click,
                                                                    cmsMultiEdit.Click,
                                                                    cmsFastEdit.Click,
                                                                    cmsColSelect.Click,
                                                                    cmsColAutoSize.Click,
                                                                    cmsCopy.Click,
                                                                    cmsExportXls.Click,
                                                                    cmsSelectAll.Click,
                                                                    cmsHistorie.Click,
                                                                    cmsInfo.Click
        Select Case True
            Case sender Is cmsNew : createNew()
            Case sender Is cmsEdit : Edit()
            Case sender Is cmsMultiEdit : MultiEdit()
            Case sender Is cmsFastEdit : FastEdit()
            Case sender Is cmsColSelect
            Case sender Is cmsColAutoSize : dgv.SetDgvColumnWidthAutosizeOnce
            Case sender Is cmsCopy : dgv.CopyOrExportSelection(False)
            Case sender Is cmsExportXls : dgv.CopyOrExportSelection(True)
            Case sender Is cmsSelectAll : dgv.SelectAll()
            Case sender Is cmsHistorie
            Case sender Is cmsInfo : dgv.Info
        End Select
    End Sub

#End Region 'Clickables

#Region "Daten"

    Private Sub createNew()
        bsAnrede.ShowCreateNewDialog(Of dlgAnrede)
    End Sub

    Private Sub Edit()
        RemoveHandler dgv.RowPrePaint, AddressOf dgv_RowPrePaint
        bsAnrede.ShowEditDialog(Of dlgAnrede)
        AddHandler dgv.RowPrePaint, AddressOf dgv_RowPrePaint
    End Sub

    Private Sub MultiEdit()
        RemoveHandler dgv.RowPrePaint, AddressOf dgv_RowPrePaint
        dgv.ShowMultiEditDialog(Of dlgAnrede)
        AddHandler dgv.RowPrePaint, AddressOf dgv_RowPrePaint
    End Sub

    Private Sub FastEdit()
        dgv.FastEdit(cmsFastEdit)
    End Sub

#End Region 'Daten

#Region "DGV"

    Private Sub dgv_CellDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles dgv.CellDoubleClick
        If Not e.RowIndex < 0 Then Edit()
    End Sub

    Private Sub dgv_RowPrePaint(sender As Object, e As DataGridViewRowPrePaintEventArgs) Handles dgv.RowPrePaint
        Dim rw = DirectCast(DirectCast(dgv.Rows(e.RowIndex).DataBoundItem, DataRowView).Row, AnredeRow)
        dgv.ConditionedDgvRowForeColor(e, Not rw.Aktiv)
    End Sub

    Private Sub dgv_DataBindingComplete(sender As Object, e As EventArgs) Handles dgv.DataBindingComplete
        dgv.ShowTotalRowsCounterInToolStripLabel(tssGesamt)
    End Sub

    Private Sub dgv_SelectionChanged(sender As Object, e As EventArgs) Handles dgv.SelectionChanged
        dgv.ShowSelectedRowsCounterInToolStripLabel(tssMarkiert)
    End Sub

    Private Sub dgv_KeyDown(sender As Object, e As KeyEventArgs) Handles dgv.KeyDown
        Select Case e.KeyCode
            Case Keys.Enter : Edit()
            Case Keys.Insert : createNew()
            Case Keys.Delete : dgv.DeleteRows(e)
        End Select
    End Sub

#End Region 'DGV

End Class